var coeff = 1.0;   // Коэффициент масштабирования веб-интерфейса
var CurrentPlaylist = null; //Выбранный плейлист
var CurrentSong = null; // Выбранный трек, индекс
var PlayingSong = null; // Воспроизводимый трек, индекс
var Albums = new Object(); // Список альбомов плейлиста  Структура: Albums(полное описание) AlbumsS (только название) Authors Years Songs<Songs,SongsLen> Playlists
var CurrentAlbum = null; //Выбранный альбом, числовой индекс
var PlayingAlbum = -1; //Воспроизводимый альбом, числовой индекс
var Volume = null;  // Громкость
var Position = null;  // Позиция воспроизведения
var Playing = false; // Состояние воспроизведения
var CurrentSongs = null; // Список песен выбранного альбома
var CurrentTime = null; // Текущее время воспроизведения в секундах
var PlayTimerId = null; // идентификатор таймера воспроизведения
var Playlists = null;  // Список плейлистов
var Drives = null;  // Список плейлистов
var PlaylistIndex = 0; // Последний выбранный плейлист
var PlaylistIndexNew = 0; // Выбранный в списке плейлист
var Paused = false; // Состояние паузы
var ModePlaylists = false; // Выводится список плейлистов
var ChangePosition = false; // Обрабатывется позиционирование в треке
var ViewPictures = true; //  Режим отображения картинок
var PlayingLen = null; // Длительность воспроизводимого трека
var PlayingName = null;  // Воспроизводимый трек, название
var PicturesInterval = 20;  // Интервал обновления картинок, сек.
var IsSafari = navigator.userAgent.indexOf('Safari') !== -1 && navigator.userAgent.indexOf('Chrome') == -1 && navigator.userAgent.indexOf('Android') == -1;
var timestamp = new Date().getTime();
var SavedAlbumIndex = 0;
var SavedSongIndex = 0;
var bFirst = false;
var OldViewPictures = true;
var FlagRadio = false;
var AddMode = false;
var RadioMode = false;
var ShowRPcs = true;

var openfolder = 'img/_folder_open_24.png';
var loadfolder = 'img/_eject_24.png';
var hasHGlass = false;
var AutoPlay = false;
var AddFolder = false;
var curlevel = 0;
var img;

var phone = /iPhone|iPod|Android/.test(navigator.userAgent);
var iOS = /iPhone|iPod|iPad/.test(navigator.userAgent);
var arr;
var leveltop = [0,0,0,0,0,0,0,0,0,0,0];
var NeedAlbums = false;

// Инициализация при загрузке
$.getJSON('?GetAlbums', ParseAlbums);
window.onblur = OnBlur;
window.onfocus = OnFocus;
SetTimer();

function rgb2hex(red, green, blue) {
    var rgb = blue | (green << 8) | (red << 16);
    return '#' + (0x1000000 + rgb).toString(16).slice(1)
}
function curColor(proc) {
    var r = Math.round(34+ proc * ( 255-34));
    var g = Math.round(139 - proc * 139);
    var b = Math.round(34 - proc * 34);;
    return rgb2hex(r,g,b);
}

function StopTimer()
{
    if (IsSafari)
	return;
    if (PlayTimerId != null)
    {
	clearInterval(PlayTimerId);
	PlayTimerId = null;
    }
}

function SetTimer()
{
    StopTimer();
    if (PlayTimerId == null)
        PlayTimerId = setInterval('PlayTimer()', 1000);
}

function OnBlur()
{
    StopTimer();
}

/* ---------------------------- */
var hammertime;
function OnPicture(){
  var startScale = 1;
  var fixHammerjsDeltaIssue = undefined;
  var pinchStart = { x: undefined, y: undefined }
  var lastEvent = undefined;

  if ($('#Image').attr('data-width') == -1) return;

  if (iOS) {
    var wrap = document.getElementById('picturewrap');
    wrap.innerHTML = '';
    var image = document.getElementById('Image');
    if (image.detachEvent) {
	image.detachEvent('onclick', OnPicture)
    } else {
        image.removeEventListener('click',OnPicture);
    }
    wrap.appendChild(image);
    $('#Image').css('width',($('#Image').attr('data-width')+'px'));
    $('#Image').css('height',($('#Image').attr('data-height')+'px'));
    image.id = 'fullimg';
    $('#Image2').show();
  } else {
    $('#fullimg').attr('src',img.src); //<--  #Image
      $('#fullimg').attr('data-width',img.width);
      $('#fullimg').attr('data-height',img.height);
    $('#fullimg').css('width',img.width);
    $('#fullimg').css('height',img.height);
  }

    var originalSize = {
	width:0,
	height:0
    };
    var current = {
        x: 0,
        y: 0,
        z: 1,
        zooming: false,
        width: 0,
        height: 0,
    }

    var last = {
        x: 0,
        y: 0,
        z: 0
    }

    function getRelativePosition(element, point, originalSize, scale) {
        var domCoords = getCoords(element);

        var elementX = point.x - domCoords.x;
        var elementY = point.y - domCoords.y;

        var relativeX = elementX / (originalSize.width * scale / 2) - 1;
        var relativeY = elementY / (originalSize.height * scale / 2) - 1;
        return { x: relativeX, y: relativeY }
    }

    function getCoords(elem) { // crossbrowser version
        var box = elem.getBoundingClientRect();

        var body = document.body;
        var docEl = document.documentElement;

        var scrollTop = window.pageYOffset || docEl.scrollTop || body.scrollTop;
        var scrollLeft = window.pageXOffset || docEl.scrollLeft || body.scrollLeft;

        var clientTop = docEl.clientTop || body.clientTop || 0;
        var clientLeft = docEl.clientLeft || body.clientLeft || 0;

        var top  = box.top +  scrollTop - clientTop;
        var left = box.left + scrollLeft - clientLeft;

        return { x: Math.round(left), y: Math.round(top) };
    }

    function scaleFrom(zoomOrigin, currentScale, newScale) {
        var currentShift = getCoordinateShiftDueToScale(originalSize, currentScale);
        var newShift = getCoordinateShiftDueToScale(originalSize, newScale)

        var zoomDistance = newScale - currentScale
        var shift = {
    	x: currentShift.x - newShift.x,
    	y: currentShift.y - newShift.y,
        }

        var output = {
            x: zoomOrigin.x * shift.x,
            y: zoomOrigin.y * shift.y,
            z: zoomDistance
        }
        return output
    }

    function getCoordinateShiftDueToScale(size, scale){
	var newWidth = scale * size.width;
        var newHeight = scale * size.height;
	var dx = (newWidth - size.width) / 2
	var dy = (newHeight - size.height) / 2
	return {
	    x: dx,
	    y: dy
	}
    }

    function update() {
        current.height = Math.round(originalSize.height * current.z);
        current.width = Math.round(originalSize.width * current.z);
	var minx = Math.round((current.width - originalSize.width)/2);
	var maxx = window.innerWidth - originalSize.width - (current.width - originalSize.width)/2;
	if (minx > maxx) {
	    var c = maxx;
	    maxx = minx;
	    minx = c;
	}
	if (current.x < minx) current.x = minx;
	if (current.x > maxx) current.x = maxx;

	var miny = Math.round((current.height - originalSize.height) / 2);
	var maxy = window.innerHeight - originalSize.height  - (current.height - originalSize.height)/2;
	if (miny > maxy) {
	    var c = maxy;
	    maxy = miny;
	    miny = c;
	}
	if (current.y < miny) current.y = miny;
	if (current.y > maxy) current.y = maxy;
        element.style.transform = "translate3d(" + current.x + "px, " + current.y + "px, 0) scale(" + current.z + ")";
    }

    function Init2(){
	originalSize = {
	    width: $('#fullimg').attr('data-width'),
	    height: $('#fullimg').attr('data-height')
	}
        current = {
         x: 0,
         y: 0,
         z: 1,
         zooming: false,
         width: originalSize.width * 1,
         height: originalSize.height * 1,
        }
        last = {
         x: 0,
         y: 0,
         z: 0
        }

        var ratio = window.innerWidth / window.innerHeight;
	var imgratio = originalSize.width / originalSize.height;
	if (ratio >imgratio) {
          current.height = window.innerHeight;
          current.width = Math.round(imgratio * window.innerHeight);

    	  current.x = Math.round(window.innerWidth - originalSize.width)/2;
          current.y = 0;
          current.z = window.innerHeight / originalSize.height;
        } else {
          current.width = window.innerWidth;
          current.height = Math.round(imgratio * window.innerWidth);
          current.x = 0;
          current.y = Math.round(window.innerHeight - originalSize.height)/2;
          current.z = window.innerWidth / originalSize.width;
        }
        startScale = current.z;
        last.x = current.x;
        last.y = current.y;
        last.z = current.z;
	update();
    }

    var element = document.getElementById('fullimg');
    hammertime = new Hammer(element, {});
    Init2();

    hammertime.get('pinch').set({ enable: true });
    hammertime.get('pan').set({ threshold: 0 });


    hammertime.on('doubletap', function(e) {
        var scaleFactor = 1;
        if (current.zooming === false) {
    	    $('#picturebox').addClass('zoomed');
            current.zooming = true;
        } else {
    	    $('#picturebox').removeClass('zoomed');
            current.zooming = false;
            scaleFactor = startScale;
        }

        element.style.transition = "0.3s";
        setTimeout(function() {
            element.style.transition = "none";
        }, 300)

        var zoomOrigin = getRelativePosition(element, { x: e.center.x, y: e.center.y }, originalSize, current.z);
        var d = scaleFrom(zoomOrigin, current.z, scaleFactor)
        current.x += d.x;
        current.y += d.y;
        current.z += d.z;

        last.x = current.x;
        last.y = current.y;
        last.z = current.z;

        update();
    });

    hammertime.on('pan', function(e) {
        if (lastEvent !== 'pan') {
            fixHammerjsDeltaIssue = {
                x: e.deltaX,
                y: e.deltaY
            }
        }

        current.x = last.x + e.deltaX - fixHammerjsDeltaIssue.x;
        current.y = last.y + e.deltaY - fixHammerjsDeltaIssue.y;
        lastEvent = 'pan';
        update();
    });

    hammertime.on('pinch', function(e) {
        var d = scaleFrom(pinchZoomOrigin, last.z, last.z * e.scale)
        current.x = d.x + last.x + e.deltaX;
        current.y = d.y + last.y + e.deltaY;
        current.z = d.z + last.z;
        lastEvent = 'pinch';
        update();
    });

    var pinchZoomOrigin = undefined;
    hammertime.on('pinchstart', function(e) {
        pinchStart.x = e.center.x;
        pinchStart.y = e.center.y;
        pinchZoomOrigin = getRelativePosition(element, { x: pinchStart.x, y: pinchStart.y }, originalSize, current.z);
        lastEvent = 'pinchstart';
    });

    hammertime.on('panend', function(e) {
        last.x = current.x;
        last.y = current.y;
        lastEvent = 'panend';
    });

    hammertime.on('pinchend', function(e) {
        last.x = current.x;
        last.y = current.y;
        last.z = current.z;
        lastEvent = 'pinchend';
    });

    document.querySelector('.update').addEventListener('click', function(){
	img = new Image();
        {
	  var imgstr = '?GetImage&pl=' + PlaylistIndex + '&image=' + CurrentAlbum + '&time=' + (new Date()).getTime();
	  img.src = imgstr;
        }
        img.onload = function() {
	    if (!iOS) {
              $('#Image').attr('src',img.src);
	         $('#Image').attr('data-width',img.width);
                 $('#Image').attr('data-height',img.height);
            }
            $('#fullimg').attr('src',img.src);
                $('#fullimg').attr('data-width',img.width);
                $('#fullimg').attr('data-height',img.height);
            $('#fullimg').css('width',img.width);
            $('#fullimg').css('height',img.height);
	    Init2();
        }


    });
    
    myPict.show();
}

function PlistShow()
{
    mySaveplist.show();
}

function OnFocus()
{
   if (coeff!=1.0)
   {
     var elm = document.getElementById('all');
     if (navigator.userAgent.indexOf('Firefox')!=-1) elm.style.boxShadow='none';
     elm.style.webkitTransform = elm.style.msTransform =  elm.style.mozTransform =   elm.style.transform = 'scale('+coeff+')';
   }
   UpdateState();
   if (PlayTimerId == null)
        SetTimer();
}

function fillFolders(data)
{
    arr = [];
    Playlists = data.Playlists;
    Drives = data.Drives;
    var j=0;
    $('#Folders').empty();
    $('#Playlists').empty();
    if (Playlists != null && Playlists.length > 0)
    {
	$('#bread').empty();
	 var len = Drives.length;
	 var k = -1;
	 var path = '';
	 var lev = -1;
	 for (i=0;i<len;i++) {
            if (Drives[i].expanded == 1) { 
        	k = i;
        	path = Drives[i].path;
        	lev = Drives[i].level;
            }
         }
         var ll = lev;
         var kk = k + 1;
         if (k > -1) { 
           path = path.slice(0, -1);
           var name = path.split('\\').pop();
           arr.push({"num":k,"name":name,"position":0});
           j++;
         }
         while (lev > 0) {
           lev--;
           for (i=k; i>0;i--) {
            if ( lev == Drives[i].level) {
        	path = Drives[i].path;
        	k = i;
        	break;
            }
           }           
           name = Drives[i].name;  
           arr.push({"num":k,"name":name,"position":0});
           j++;
         }
         //if (rootfolder == '')
            arr.push({"num":-2,"name":"root","position":0});
	 var len2 = arr.length-1;
	 for (i=len2;i>=0;i--)
	    $('#bread').append('<li class="breadcrumb-item'+(i==0 ? ' active':'')+'"><a '+'class="clickable" onclick="SelectPlaylist(' + arr[i].num + ',1);"'+'>'+arr[i].name+'</li>');
//------------------------------------
         for (i=kk;i<len;i++) {
	    if (Drives[i].level <= ll) {
		break
	    } else {        
        var name = Drives[i].name;
		var exp = Drives[i].expanded;
		if (name!='') {
		  $('#Folders').append('<tr class="playliststr"'+(exp == 2 ? '><td class="type exp">':' onclick="SelectPlaylist(' + i + ')"><td class="type">')+
        	'<img src="img/_folder_open_24.png"></td><td class="title"><div>'+name + '</div></td>'+
        	'<td class="action"><a class="ripple" onclick="playadd(true,'+i+',event);" title="add"><img src="img/_add_24.png"></a></td>'+
        	'<td class="action"><a class="ripple" onclick="playadd(false,'+i+',event);" title="play"><img src="img/_play_24.png"></a></td></tr>');
        	}
	    }
         }
         for (i=0;i<len;i++) {
    	    if (Drives[i].path == '')  {
	       var name = Drives[i].name.replace('.ap2','');
	       if (name == 'aplayer.dat') name ='Last playlist';
    	       $('#Playlists').append('<tr class="playliststr" onclick="SelectPlaylist(' + i + ')"><td class="type">' + 
        	'<img src="img/_queue_24.png"></td><td class="title"><div>'+name + '</div></td>'+
        	'<td class="action"><a onclick="playadd(false,'+i+',event);" title="play"><img src="img/_play_24.png"></a></td></tr>');
    	    }
	    else
		break;
         }
	 var scr = document.getElementById('scrollbox');
	 if (curlevel > len2+1) {
	    scr.scrollTop = leveltop[len2+1];
	    }
	 else if (curlevel < len2+1)
	    scr.scrollTop = 0;
	 curlevel = len2 + 1;
    }
    RemoveHourglass();
}


function MakeHourglass()
{
     $('#spinner').show();
     hasHGlass = true;
}

function RemoveHourglass()
{
    $('#spinner').hide();
    hasHGlass = false;
}

function ReturnToSongs()
{
    $('#Input').css('display', 'none');
    $('#Filter').css('display', 'block');
    $('#Topcontrols').css('display', 'block');    
    if (OldViewPictures)
	ChangeImage();
    if (!AddMode && PlaylistIndex != -1) {
          $('#Albums').empty();
          $('#Songs').empty();
    }
}

function openLib(){
    if (phone)
	mySwiper.scroll(2,true)
    else {
	if (mySwiper.index == 0) {
	    mySwiper.scroll(2,true);
	    window.setTimeout(function(){
	       $('#scrollbox').focus();
	    },800);
	}
	else
	    mySwiper.scroll(0,true);
	    window.setTimeout(function(){
	       $('#SongsBlock').focus();
	    },700);
    }
}

function play_(mode,index) {
  if (mode){ //add 
    AddFolder = true;
    $.getJSON('?Get_Playlist&playlist=' + index, ParseStd);
  }
  else {
    AutoPlay = true;
    CurrentSong = 0;
    $.getJSON('?GetPlaylist&playlist=' + index, ParseStd);
  }
}

function playadd(mode,index,event) {
  event.stopPropagation();
  MakeHourglass();
  CurrentSong = 0;
  CurrentAlbum = 0;
  NeedAlbums = true;
  if (RadioMode) { 
    OnRadio();
    setTimeout(play_(mode,index), 2000);
  }
  else
     play_(mode,index);
}

function mode2(){
    var mode = $('#modePL').attr('data-mode');
    if (mode == 'lib') {
	$('#modePL').attr('data-mode','plist');
	$('#modePL').text('Playlists');
	$('#breadWrapper').hide();
	$('#Folders').hide();
	$('#Playlists').show();
    } else {
	$('#modePL').attr('data-mode','lib');
	$('#modePL').text('Music Library');
	$('#Playlists').hide();
	$('#breadWrapper').show();
	$('#Folders').show();
    }
}

function OnSelect(add)
{
    if (hasHGlass)
	return;
	
    if (ModePlaylists == false)
    {

        PlaylistIndex = PlaylistIndexNew = -1;
      $.getJSON('?GetPlaylists&ind=-1', fillFolders);
      ModePlaylists = true;
    }
    else
    {
    	if (PlaylistIndexNew != -1)
   	   StopCommand(ParseStd);

        if (PlaylistIndexNew == null)
    	    PlaylistIndexNew = 0;
        PlaylistIndex = PlaylistIndexNew;
  	
        if (PlaylistIndex != -1)
        {
	      MakeHourglass();
        }
            ModePlaylists = false;
            if (!phone) {
              $('#Albums').css('visibility', 'visible');
              $('#Songs').css('display', '');
              ReturnToSongs();
              $('#Topcontrols').css('display', 'block');
            }
    }

}

function ChangeImage()
{
    console.log('changeimage()');
    img = new Image();
    var imgstr = '?GetImage&pl=' + PlaylistIndex + '&image=' + CurrentAlbum + '&time=' + (new Date()).getTime();
    img.src = imgstr;
    img.onload = function() {
      $('#Image').attr('src',imgstr);
        $('#Image').attr('data-width',img.width);
        $('#Image').attr('data-height',img.height);
      $('#bg').css('background-image',"url('"+imgstr+"')");
    };
}


function OnViewAlbum()
{
   if (!Playing)
        return;
    var trackinfo = $('#lSong').text();
    var $tempinp = $("<input id='inptmp'>");
    $("body").append($tempinp);
    $tempinp.val(trackinfo);
    var tempinput=document.getElementById('inptmp');
    tempinput.focus();
    tempinput.setSelectionRange(0, tempinput.value.length);
    document.execCommand("copy");
    $tempinp.remove();	
   if (CurrentAlbum != PlayingAlbum)
   {
    CurrentAlbum = PlayingAlbum;
    $('#Albums')[0].selectedIndex = CurrentAlbum;
    if (Albums.Songs != null && Albums.Songs.length > 0)
    {
        $.getJSON('?GetSongs&album='+ CurrentAlbum, ParseSongs);
    }
   }
   UpdateRadioPicture();
}

function ProgressChange(pos)
{
    if (!Playing) {
        $('#progress')[0].value = 0;
        $('#progress').css('background','rgba(0,0,0,0.3)');
    }
    else
    {
        ChangePosition = true;        
        var pos2 = Math.round(pos * 232.0 / 100.0);
        PositionCommand(pos2);
        CurrentTime = PlayingLen / 1000 * pos / 100;
    }
}

function GetLenText(len) // Время в формате 0:00:00
{
    var Playtime = len / 1000; // sec
    var result = '';
    if (Playtime >= 3600)
    {
	result = result + Math.round(Playtime/3600 - 0.5) + ':';
	Playtime = Playtime%3600;
    }
    result = result + (Playtime >= 600 ? Math.round(Playtime/60 - 0.5):'0' + Math.round(Playtime/60 - 0.5))+':';
    var ost = Math.round(Playtime % 60 - 0.5);

    result = result  + (ost > 9 ? ost: '0' + ost);
    return result;
}

function ParseSongs(data)
{
    var Songs = data.Songs;
    var SongsLen = data.SongsLen;
    var slen;
    var val2 = '';
    CurrentSongs = Songs;
    $('#Songs').empty(); 

    if (Songs != null && Songs.length > 0)
    {
        $.each(Songs, function (ind, val) {
           slen = GetLenText(SongsLen[ind]);
	   val2 = val.replace('.flac',' ');
	   if (RadioMode) //RadioMode
             $('#Songs').append('<tr class="songstr" onclick="SelectSong(' + ind + ');PlayCommand2(' + ind + ');"><td class="sNum">'+(ind+1)+'</td><td class="sTitle">' + val2 + '</td><td class="sEdit"></td></tr>')
	   else
             $('#Songs').append('<tr class="songstr" onclick="SelectSong(' + ind + ');PlayCommand2(' + ind + ');"><td class="sNum">'+(ind+1)+'</td><td class="sTitle">' + val2 + '</td><td class="sLen">'+slen+'</td></tr>'); 
        }); 
	if (Playing && CurrentAlbum == PlayingAlbum)
        {
            SelectSong(PlayingSong);
        }
        else {
            if (bFirst)
                  SelectSong(SavedSongIndex);
            else
               SelectSong(-1);
        }
    }
    else
        CurrentSong = null;
}

function ParseAlbums(data)
{
    ModePlaylists = false;
    $('#Albums').css('visibility', 'visible');
    $('#Songs').css('display', '');
    $('#Topcontrols').css('display', 'block');
    Albums.Albums = data.Albums;
    Albums.Authors = data.AuthorList;
    Albums.Songs = data.Songs;
    Albums.AlbumsS = data.AlbumList;
    Albums.Years = data.YearList;
    Playlists = data.Playlists;
    SavedAlbumIndex = data.SavedAlbumIndex;
    SavedSongIndex = data.SavedSongIndex;

    RadioMode = data.RadioMode;
    if (RadioMode)
    {
        $('#bRadio').attr('src', 'img/radioa.png');
        $('#bMinus').hide();
        $('#bSave').hide();
        $('#bPlus').show();
        $.each(Albums.Albums, function (ind, val) { 
    	    var pos = val.lastIndexOf('[');
    	    if (pos > 0) Albums.Albums[ind]=val.substring(0, pos-1);
    	});
    } else {
        $('#bRadio').attr('src', 'img/radiop.png');
        $('#bPlus').hide();
        $('#bMinus').show();
        $('#bSave').show();
    }

    $('#Albums').empty();
    $('#Songs').empty();
    if (Albums.Albums != null && Albums.Albums.length > 0) {
        CurrentAlbum = SavedAlbumIndex;
        var imgstr = '?GetImage&pl=' + PlaylistIndex + '&image='+ CurrentAlbum + '&time=' + (new Date()).getTime();
        img = new Image();
    	img.src = imgstr;
        img.onload = function() {
         $('#Image').attr('src',imgstr);
            $('#Image').attr('data-width',img.width);
            $('#Image').attr('data-height',img.height);

          $('#bg').css('background-image',"url('" + imgstr +"')");
        }
        $.each(Albums.Albums, function (ind, val) { $('#Albums').append('<option value=' + ind + ' title="'+ val +'" style="font-size:14px;">' + val + '</option>'); });
        $("#Albums option[value='"+ SavedAlbumIndex  + "']").prop('selected', true);
        if (Albums.Songs != null && Albums.Songs.length > 0)
        {
            bFirst = true;
            ParseSongs(Albums.Songs[0]);
            bFirst = false;
        }
    }
    else 
    {
        CurrentAlbum = null;
        $('#Image').attr('src','img/noimage.png');
          $('#Image').attr('data-width',-1);
          $('#Image').attr('data-height',-1);
    }
    SelectSong(SavedSongIndex);

    RemoveHourglass(); 
    UpdateState();

    if (AutoPlay) {
	PlayCommand();
	SelectSong(-1);
	AutoPlay = false;
	if (mySwiper) mySwiper.scroll(0,true);
    }
    $('#SongsBlock').scrollTop(0);
}

function ParseStd(data)
{
    var res = data.Result;
    if (res != 'OK')
        DisplayError(res)
    UpdateState();
}

function PlayTimer() 
{
    if (ChangePosition)
        return;
    var len = PlayingLen;
    if (Playing)
    {
         if (!Paused)
         {
             CurrentTime = CurrentTime + 1;
             // Pictures rotator             
             if (Math.floor(CurrentTime) % PicturesInterval == 0 && CurrentAlbum == PlayingAlbum && ViewPictures)
             {
		 var imgstr = '?GetImage&pl=' + PlaylistIndex + '&image=' + CurrentAlbum + '&time=' + (new Date()).getTime();
		 img = new Image();
		 img.src = imgstr;
		 img.onload = function() {
                   $('#Image').attr('src',img.src);
    		     $('#Image').attr('data-width',img.width);
    		     $('#Image').attr('data-height',img.height);
                 }
             }

         }
         var posi = CurrentTime * 1000 / len * 100;
         $('#progress')[0].value = posi;
	 $('#progress').css('background','linear-gradient(to right, rgb(73,150,227) 0%, rgb(73,150,227) ' + posi + '%, rgba(0,0,0,0.3) ' + posi + '%, rgba(0,0,0,0.3) 100%)');
         $('#lTime').text(GetLenText(CurrentTime * 1000));
             current = new Date().getTime();
             if (current - timestamp > 2500)
                 len = 0;
             timestamp = current;
    }
    if (($('#lKhz').text() == '' || len /1000 - CurrentTime < 5  || $('#progress').css('visibility') == 'hidden' || CurrentTime < 5) &&Playing || Paused || hasHGlass) {
        UpdateState();
    }
    if (Playing && RadioMode && Math.floor(CurrentTime) % 10 == 0)
    {
        $.getJSON('?GetRadio', ParseRadio);
        if (Math.floor(CurrentTime) % PicturesInterval == 0 && CurrentAlbum == PlayingAlbum && ViewPictures)
        {
            UpdateRadioPicture();
        }
    }
}

function UpdateRadioPicture()
{
        ChangeImage();
}

function ParseRadio(data)
{
    var txt = data.RadioTitle;
    if ($('#lSong').text() != txt) 
    {
        $('#lSong').text(txt);
    }
}

function ParsePlay(data)
{
    CurrentTime = 0;
    if (PlayTimerId == null)
       SetTimer();
    var res = data.Result;
    if (res != 'OK')
    {
        DisplayError(res);
        Playing = false;
        $('#lTime').text('');
    }
    else
    {
        $('#lTime').text('00:00');
        Playing = true;
    }
    UpdateState();
}

function ParseStopPlay(data)
{
    var res = data.Result;
    if (res != 'OK')
         DisplayError(res)
    Playing = false;

    PlayCommand();
}

function ChangeAlbum(obj)
{
    if (hasHGlass)
      return;
    CurrentAlbum = $(obj).val();
    $.getJSON('?GetSongs&album='+ CurrentAlbum, ParseSongs);
    UpdateRadioPicture();
}

function PlayCommand()
{
    if (CurrentAlbum == null || CurrentSongs == null || Playing || CurrentSongs.Length == 0 || hasHGlass)
        return;
    PlayingSong = CurrentSong;
    PlayingAlbum = CurrentAlbum;
    if (CurrentSong < 0 || CurrentSong > CurrentSongs.length -1)
        PlayingSong=CurrentSong = 0;
    $('#lRadio').text('');     
     $.getJSON('?Play&album='+ CurrentAlbum+'&song='+CurrentSong, ParsePlay);
}

function PlayCommand2(ind)
{
    CurrentSong = ind;
    if (Playing)
        StopCommand(ParseStopPlay)
    else
        PlayCommand();
}

function SelectSong(ind)
{
    CurrentSong = ind;
    $.each($('#Songs').children(), function (ind2, val) {
        if (ind == ind2)
	    $(val).addClass('songactive')
        else
	    $(val).removeClass('songactive');
    });
}

function SelectPlaylist(ind, val)
{
    MakeHourglass();
    if (ind == -2) {
	$.getJSON('?GetPlaylists&ind=-2',fillFolders);
	return;
    }
    if (PlaylistIndexNew != ind)
    {
        PlaylistIndexNew = ind;
    } 
    leveltop[curlevel] = document.getElementById('scrollbox').scrollTop;
      if (val == undefined) {
	$.getJSON('?GetPlaylists&ind=' + ind, fillFolders)
      }
      else { 
 	$.getJSON('?GetPlaylists&ind=' + ind);
	$.getJSON('?GetPlaylists&ind=' + ind, fillFolders);
      }
}

function StopCommand(parser)
{
    $('#lTime').text('');
    $('#lTotalTime').text('');
    $('#progress')[0].value = 0;
    $('#progress').css('background','rgba(0,0,0,0.3)');
    $.getJSON('?Stop', parser);
}

function PositionCommand(pos)
{
    if (!Playing)
        return;
    $.getJSON('?Position&pos='+ pos.toString(), ParseStd);
}

function VolumeCommand(vol)
{
    var volume = Math.round(vol * 255.0 / 100.0);
    if(volume > 255)
	volume = 255;
    else
	if(volume < 0)
 		volume = 0;	
    $.getJSON('?SetVolume&volume='+ volume.toString(), ParseVolume);
}

function PauseCommand()
{
    if (!Playing) 
	return;
    $.getJSON('?Pause', ParseStd);
}

function NextCommand()
{
    if (!Playing)
            return;
    $('#progress')[0].value = 0;
    $('#progress').css('background','rgba(0,0,0,0.3)');
    $.getJSON('?Next', ParsePlay);
}

function PrevDown()
{
    $('#bPrev').css('opacity', '1');
    $('#bPrev').css('filter', 'invert(71%) sepia(8%) saturate(2318%) hue-rotate(137deg) brightness(259%) contrast(90%)');
}

function PrevUp()
{
    $('#bPrev').css('opacity', '');
    $('#bPrev').css('filter', 'none');
}

function PlayDown()
{
   $('#bPlay').css('opacity', '1');
   $('#bPlay').css('filter', 'invert(71%) sepia(8%) saturate(2318%) hue-rotate(137deg) brightness(259%) contrast(90%)');
   if (Playing)
     PauseCommand();
}

function PlayUp()
{
   $('#bPlay').css('opacity', '');
   $('#bPlay').css('filter','none');

   if (Playing) {
     if (!Paused)
        $('#bPlay').attr('src', 'img/pauser.png')
     else
        $('#bPlay').attr('src', 'img/playr.png');
   }
}

function NextDown()
{
   $('#bNext').css('opacity', '1');
   $('#bNext').css('filter', 'invert(71%) sepia(8%) saturate(2318%) hue-rotate(137deg) brightness(259%) contrast(90%)');
}

function NextUp()
{
    $('#bNext').css('opacity', '');
    $('#bNext').css('filter','none');
}

function PrevCommand()
{
    if (!Playing)
        return;
    $('#progress')[0].value = 0;
    $('#progress').css('background','rgba(0,0,0,0.3)');
    $.getJSON('?Prev', ParsePlay);
}

function HideError()
{
    $('#lError').css('display', 'none');
}

function DisplayError(error)
{
    $('#lError').text(error);
    $('#lError').css('display', 'block');
    setTimeout('HideError()', 3000);
}

function ParseVolume(data)
{
    ChangePosition = false;
}


function ParseState(data)
{
    ChangePosition = false;
    if (data.Scanning) {
       if (!hasHGlass) {
          MakeHourglass();
       }
    }
    else {
       if (hasHGlass) {
          RemoveHourglass();
          if (AddFolder) {
    	      AddFolder = false;
    	  }
    	 if(NeedAlbums)
    	   {
    	    $.getJSON('?GetAlbums', ParseAlbums);
    	    NeedAlbums = false;    
           }
          }
    }
    if (Volume == null) {
        var vol = document.getElementById('volume');
	vol.value = Volume = Math.round(data.Volume * 100 / 255); 
	vol.style.background = 'linear-gradient(to right, forestgreen 0%, ' + curColor(Volume*0.01) + ' '+ Volume + '%, rgba(0,0,0,0.3) ' + Volume + '%, rgba(0,0,0,0.3) 100%)';
	$('#volValue').text(Volume+'%');
     }
     if (RadioMode != data.RadioMode)
     {
         RadioMode = data.RadioMode;
         if (RadioMode) {
             $('#bRadio').prop('src', 'img/radioa.png');
         }
         else {
             $('#bRadio').prop('src', 'img/radiop.png');
         }
     }
     if (RadioMode && (Boolean(ShowRPcs) != Boolean(data.RadioPictures)))
     {
        ShowRPcs = data.RadioPictures;     
	    UpdateRadioPicture();
    }
    
    if (!data.Playing)
    {
        Playing = false;
        $('#progressbox').hide();
        
        $('#lArtist').text('');
        $('#lArtist').attr('title','');
        $('#lAlbum').text('');
        $('#lAlbum').attr('title','');
        $('#lYear').text('');
        $('#lNum').text('');
        $('#lSong').text('');
        $('#lSong').attr('title','');
  	if (!hasHGlass) {       	
  	    $('#lFormat').text('');
            $('#lRadio').text('');
        }
        $('#lLength').text('');
        $('#lTime').text('');
        $('#bPlay').attr('src', 'img/playr.png')
        $('#tFormat').html('');

        CurrentTime = 0;
        PlayingLen = 0;
        PlayingName = '';
        $('#progress')[0].value = 0;
        $('#progress').css('background','rgba(0,0,0,0.3)');

    }
    else
    {
        $('#progressbox').show();
	var new_alb = PlayingAlbum != data.Album;
        Playing = true;
        if (PlayTimerId == null)
             SetTimer();
        PlayingAlbum = data.Album;
        PlayingSong = data.Song;
        if (PlayingAlbum == CurrentAlbum) {
            SelectSong(PlayingSong);
        }
        else {
            if (new_alb)
            {
                OnViewAlbum();
                SelectSong(PlayingSong);
            }
            else {
                SelectSong(-1);
            }
        }
        $('#lArtist').text(Albums.Authors[data.Album]);
        $('#lArtist').attr('title', $('#lArtist').text());
        var format = '';
        if (RadioMode) {
    	    $('#lRadio').hide();
            $('#lRadio').text('');
    	    $('#lAlbum').text(Albums.AlbumsS[data.Album]+': '+PlayingName);
    	    $('#lSong').text('');
	} else {
    	    $('#lRadio').show();
    	    $('#lAlbum').text(Albums.AlbumsS[data.Album]);
    	    $('#lAlbum').attr('title', $('#lAlbum').text());
    	    var lsong = '';
    	    if (PlayingName)
    	      if (PlayingName.indexOf('.flac') >-1) {
    		format = 'FLAC&emsp;&bull;&emsp;';
    		lsong = PlayingName.replace('.flac','');
    	      } else
    	      if (PlayingName.indexOf('.wav') >-1) {
    		format = 'WAV&emsp;&bull;&emsp;';
    		lsong = PlayingName.replace('.wav','');
    	      } else
    	        lsong = PlayingName;

    	    $('#lSong').text(lsong);
    	    $('#lSong').attr('title', $('#lSong').text());
    	}
        $('#lYear').text(Albums.Years[data.Album]);
        $('#lNum').text((data.Song+1).toString()+'. ');
        PlayingName = data.PlayingName;
        if (data.Freq > 0 && data.Bitrate > 0) 
            var s1 = data.Bitrate+' kbps'+'&emsp;&bull;&emsp;'+(data.Freq > 1000000 ? data.Freq / 1000000+' MHz':data.Freq+' kHz')
        else
    	    var s1 = '';
        $('#tFormat').html(format + s1 + (s1 ? '&emsp;&bull;&emsp;':'')+ data.Bps+ ' bit' + (data.Ch > 2 ?'&emsp;&bull;&emsp;'+data.Ch+' ch':''));

        PlayingLen = data.PlayingLen;
        $('#lLength').text(GetLenText(PlayingLen ));
        if (!(data.Position >= 0))
            data.Position = 0;
        if (RadioMode) 
            $.getJSON('?GetRadio', ParseRadio);
        CurrentTime = data.Position / 1000; // sec
        $('#lTime').text(GetLenText(data.Position));
        var progress_vis = data.ProgressVisible ? 'visible': 'hidden';
	var posi = CurrentTime * 1000 / PlayingLen  * 100;
	$('#progress')[0].value = posi;
	$('#progress').css('background','linear-gradient(to right, rgb(73,150,227) 0%, rgb(73,150,227) ' + posi + '%, rgba(0,0,0,0.3) ' + posi + '%, rgba(0,0,0,0.3) 100%)');
	
        if (data.Paused)
        {
            Paused = true;
            $('#bPlay').attr('src', 'img/playr.png')
        }
        else
         {
            Paused = false;
            $('#bPlay').attr('src', 'img/pauser.png')
         }
         if (data.RadioTitle.length > 0 && RadioMode) {
            var txt = data.RadioTitle;
             if ($('#lSong').text() != txt) {
                $('#lSong').text(txt);
             }
            FlagRadio = true;
        }
         else
         {
             $('#lRadio').text('');
             $('#lRadio').text((CurrentSong + 1) + '/' + CurrentSongs.length);

             FlagRadio = false;
         }
    }
}

function UpdateState()
{
    $.getJSON('?State', ParseState);
}


function PlusCommand() {
    if (hasHGlass)
        return;
    if (RadioMode)
    {
        if (Playing)
	    StopCommand(ParseStd)            
        $("#redittitle").text("Add Station");
        $('#rsect').val(Albums.Albums[CurrentAlbum]);
        $('#rname').val('');
        $('#rstat').val('');
        $('#rstat').text('');
        $('#rmess').hide();
        $("#reditrem").hide();
        $("#reditadd").show();
        myRedit.show();
        return;
    }
    if (ModePlaylists == false)
    {
        $('#PlaylistName').val('');
        $('#Input').css('display', 'block');
    }
    else
    {
       OnSelect(true);
    }
}


function ParseStation(data)
{
    $('#rstat').val(data.url);
}

function OkCommand() {
    var str = $('#PlaylistName').val();
    if (str.length > 0) {
        PlaylistIndexNew = -1;
        $.getJSON('?SavePlaylist&name='+str, OnSelect);
    }
    mySaveplist.hide();
}

function MinusCommand(event) {
    event.stopPropagation();
    if(hasHGlass)
        return;
    if(RadioMode)
    {
	if(Playing)
	    StopCommand(ParseStd);
    	$("#redittitle").text("Delete Station");
        $('#rsect').val(Albums.Albums[CurrentAlbum]);
        $('#rname').val(CurrentSongs[CurrentSong]);        
        $('#rstat').val('');        
        $("#rmess").text('');
        $('#rmess').hide();
        $("#reditadd").hide();
        $("#reditrem").show();

	myRedit.show();
        return;
    }
     if(CurrentAlbum == null)
        return;
     $("#Search").val("");
     OldViewPictures = false;
     $.getJSON('?DeleteAlbum&album='+ CurrentAlbum, ParseAlbums);
}

function VolumeChange(vol)
{
    ChangePosition = true;
    if (vol > 100)
	vol = 100
    else
	if (vol < 0)
	    vol = 0;
    $('#volume').css('background','linear-gradient(to right, forestgreen 0%, '+curColor(vol*0.01)+' ' + vol + '%, rgba(0,0,0,0.3) ' + vol + '%, rgba(0,0,0,0.3) 100%)');
    $('#volValue').text(vol +'%');

    VolumeCommand(vol);
}


function VolPlus() {
    var x = $('#volume')[0].value;
    var n =   parseInt(x)+10;
    if (n > 100) n = 100;
    $('#volume')[0].value = n;
    VolumeChange(n);
}

function VolSub() {
    var y = $('#volume')[0].value;
    var n = parseInt(y)-10;
    if (n < 0) n = 0;
    $('#volume')[0].value = n;
    VolumeChange(n);
}

function OnRadio() {
    $('#lRadio').text('');
    $('#lSong').text('');
    OldViewPictures = false;
    $.getJSON('?RadioMode', ParseAlbums);
}

//Config
var Config = null;

function OnLoadStatus(data)
{
    Config = data;
    $('#stat_root').text((Config.stat_root == 1) ? 'yes' : 'no');
    $('#stat_cores').text(Config.stat_cpus.toString());
    $('#stat_prio').text(Config.stat_prio.toString());
    $('#stat_nice').text(Config.stat_nice.toString());
    $('#stat_16bit').text((Config.stat_16bit == 1) ? 'yes' : 'no');
    $('#stat_24bit').text((Config.stat_24bit == 1) ? 'yes' : 'no');
    $('#stat_32bit').text((Config.stat_32bit == 1) ? 'yes' : 'no');
    var is_playing = Config.stat_playing == 1;
    $('#stat_play').text(is_playing ? 'yes' : 'no');
    if (is_playing)
    {
      $('#status tr.playing').show();
      $('#stat_play_file').text(Config.stat_file);
      $('#stat_period_size').text(Config.stat_period_size + ' frames, ' + Config.stat_period_time + ' µs');
      $('#stat_buffer_size').text(Config.stat_buffer_size + ' frames, ' + Config.stat_period_time*Config.stat_buffer_size/Config.stat_period_size  + ' µs');
    }
    else
    {
      $('#status tr.playing').hide();
      $('#stat_play_file').text('');
      $('#stat_period_size').text('');
      $('#stat_buffer_size').text('');
    }

}

function init_config(){
    Config = new Object();
    $.getJSON('?GetConfig', OnLoadConfig);
}

function OnLoadConfig2(data){
  //  rootfolder = data.root_folder;
    RadioMode = data.RadioMode;
  //  if (rootfolder != '') 
 //       root = true;
    if (data.volume_enabled) 
	$('#volumebox').css('display','flex');
    $('#Playlists').hide();
    OnSelect(false); // first run
}

function parseState2(data){
    Playing = data.Playing;
    PlayingSong = data.Song;
    Paused = data.Paused;
    RadioMode = data.RadioMode;
    //Position;
//    $.getJSON('?GetAlbums', ParseAlbums);
}
function checkroot(){
    Config = new Object();
    $.getJSON('?State',parseState2);
    $.getJSON('?GetConfig', OnLoadConfig2);
}


function ShowConfig()
{
    if (Config == null)
        init_config()
    else
        $.getJSON('?GetConfig', OnLoadConfig);
    myConfig.show();
}

function OnLoadConfig(data)
{
    Config = data;
   
}

function ExitApp()
{
  document.location = '/stop';
}

var myConfig;
var myRedit;
var mySaveplist;
var mySwiper;

function onResize(){
    document.querySelector(':root').style.setProperty('--vh',window.innerHeight/100+'px');
    if (!phone) {
     mySwiper.destroy();
        mySwiper = new Swiper('#all',{
	    direction: 'horizontal',
	    touchRatio:0.5,
	    slidesPerView:2,
        });
    }
}

function doOnOrientationChange(){
   if (phone) {
     mySwiper.destroy();
     setTimeout(function() {
       mySwiper = new Swiper('#all',{
	direction: 'horizontal',
	touchRatio:0.5,
	slidesPerView:(window.innerWidth > window.innerHeight ? 2 : 1),
       });
     },700);
   }
}

function Init(){
  myConfig = new Modal(document.getElementById('config_body'));
  myRedit = new Modal(document.getElementById('redit'));
  myPict = new Modal(document.getElementById('picturebox'));
  mySaveplist = new Modal(document.getElementById('saveplist'));
  var w = window.innerWidth > window.innerHeight ? window.innerHeight : window.innerWidth;
  if (phone & w > 560) phone = false;

  checkroot();
  if (phone) {
    document.body.classList.add('phone');
    var menu = document.getElementById('menu');
    var opensel = document.getElementById('opensel');
    var plist = document.getElementById('plist');
    plist.insertBefore(menu,opensel);
  } else {
    $('#SongsBlock').focus();
  }

  mySwiper = new Swiper('#all',{
	direction: 'horizontal',
	touchRatio:0.5,
	slidesPerView: (phone && window.innerWidth < 560 ? 1 : 2),
	loop:true
  });

  if (iOS) {
    const ranges = RangeTouch.setup('input[type="range"]');
  }

  document.getElementById('breadWrapper').addEventListener('touchmove',function(event){
    event.stopPropagation();
  });

  document.getElementById('volumebox').addEventListener('mousedown',function(event){
    event.stopPropagation();
  });
  document.getElementById('progressbox').addEventListener('mousedown',function(event){
    event.stopPropagation();
  });
  document.getElementById('volume').oninput = function() {
	this.style.background = 'linear-gradient(to right, rgb(73,150,227) 0%, rgb(73,150,227) ' + this.value + '%, rgba(0,0,0,0.3) ' + this.value + '%, rgba(0,0,0,0.3) 100%)';
  };

  document.getElementById('bRadio').addEventListener('click',OnRadio);
//  document.getElementById('bPlus').addEventListener('click',PlusCommand);
  document.getElementById('bOpen').addEventListener('click',openLib);
  document.getElementById('InfoBlock').addEventListener('click',OnViewAlbum);
  document.getElementById('modePL').addEventListener('click',mode2);
  document.getElementById('bMinus').addEventListener('click',function(e) {MinusCommand(e);});
  document.getElementById('bSave').addEventListener('click',PlistShow);
  document.getElementById('bMinus2').addEventListener('click',function(e) {MinusCommand(e);});
  document.getElementById('bSave2').addEventListener('click',PlistShow);

  document.querySelector(':root').style.setProperty('--vh',window.innerHeight/100+'px');
  window.addEventListener('resize',onResize);
  window.addEventListener('orientationchange', doOnOrientationChange);

  var image1 = document.getElementById("Image");
  image1.addEventListener('click',OnPicture);
  if ('ontouchstart' in document) 
    document.querySelector('body').classList.remove('no-touch');

  if (iOS) {
    var mybox =  document.getElementById("picturebox");
    mybox.addEventListener('hide.bs.modal', function(event){
	var block = document.getElementById("ImgBlock");
	var image1 = document.getElementById("fullimg");
	hammertime.off('pan');
	hammertime.off('doubletap');
	hammertime.off('pinch');
	$('#Image2').hide();
	image1.id = 'Image';
	block.appendChild(image1);
	$('#Image').css('width','');
	$('#Image').css('height','');
	$('#Image').css('transform','');
	$('#Image').css('touch-action','');
	$('#Image').css('user-select','');
	$('#Image').css('-webkit-userdrag','');
	$('#Image').css('-webkit-tap-highlight-color','');
	image1.addEventListener('click',OnPicture);

    },false);
  }
}
